/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.utils.hibernate;

import java.sql.SQLException;
import java.util.Map.Entry;

import net.sourceforge.kivu4j.utils.api.repository.QueryParameter;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.HibernateCallback;

/**
 * 批量处理回调类
 *
 * @author Lucky Yang
 */
public class BulkExecutorCallback implements HibernateCallback<Integer> {
	
	private QueryParameter parameter;
	
	public BulkExecutorCallback(QueryParameter parameter) {
		super();
		this.parameter = parameter;
	}
    
	@Override
	public Integer doInHibernate(Session session) 
		throws HibernateException, SQLException {
		
		Query query = null;
		if (this.parameter.isNative())
			query = session.getNamedQuery(this.parameter.getQuery());
		else
			query = session.createQuery(this.parameter.getQuery());
		
		for (Entry<String, Object> e : this.parameter.getParameters().entrySet()) {
			query.setParameter(e.getKey(), e.getValue());
		}
        	
        return query.executeUpdate();  
	}

}
