/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.utils.hibernate;

import java.sql.SQLException;
import java.util.Collection;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.DetachedCriteria;
import org.springframework.orm.hibernate3.HibernateCallback;

/**
 * Criteria查询回调类
 *
 * @author Lucky Yang
 */
public class CriteriaExecutorCallback<T> 
	implements HibernateCallback<Collection<T>> {
	
	private DetachedCriteria detachedCriteria;
	
	public CriteriaExecutorCallback(DetachedCriteria detachedCriteria) {
		super();
		this.detachedCriteria = detachedCriteria;
	}
    
	@SuppressWarnings("unchecked")
	@Override
	public Collection<T> doInHibernate(Session session) 
		throws HibernateException, SQLException {
		Criteria criteria 
			= this.detachedCriteria.getExecutableCriteria(session);  

        return criteria.list();  
	}

}
